--[[
##########################################################
Inked! by: keivamp
##########################################################
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local _, ns = ...
local oUF = ns.oUF
local _, playerClass = UnitClass("player")
local _, targetClass = UnitClass("target")
local addonName, addon = ...
--UF 4

local NumberFontPlayer = [["Interface\\Addons\\Inked\\Fonts\\Numbers.TTF"]]


local function CreateHealthBackdrop(frame)
    frame:SetBackdrop({bgFile = "Interface\\Addons\\Inked\\Textures\\Unit Frames\\DEFAULT_Status"})
    frame:SetBackdropColor(0.25,0.25,0.25,0.85)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreatePowerBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(0.25,0.25,0.25,0.75)
		frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreateBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -4, left = -4, bottom = -4, right = -4}})
		frame:SetBackdropColor(1,1,1,1)
		frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreateSpellBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0.15,0.15,0.15,0.65)
		frame:SetBackdropBorderColor(0.25,0.25,0.25,.85)
end

local function CreateClassPowerBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(1,.5,.5,1)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local UnitSpecific = {
	player = function(self)

		--------------------
		--  Player Set Up --
		--------------------

		local PlayerWidth = 225;
		local PlayerHeight = 65;
		self:SetSize(PlayerWidth,PlayerHeight)
		--CreateBackdrop(self)

		----------------------
		--  Player Level --
		----------------------

		local LevelText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		LevelText:SetPoint("TOPLEFT", self, -35,-5) -- but anchor to the base element so it doesn't wiggle
		LevelText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF",14,"OUTLINE")
		self:Tag(LevelText, "[level]") -- oUF will automagically update it!
		LevelText:SetAlpha(1)

		------------------
		--  Player Name --
		------------------

		local NameText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOP", self, 0,1) -- but anchor to the base element so it doesn't wiggle
		NameText:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 16, "OUTLINE")
		NameText:SetWidth(200)
		self:Tag(NameText, "[name]") -- oUF will automagically update it!
		--[[
		local NameText2 = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText2:SetPoint("CENTER", NameText, -3,-3) -- but anchor to the base element so it doesn't wiggle
		NameText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 16, "OUTLINE")
		NameText2:SetWidth(200)
		NameText2:SetTextColor(0,0,0,0.75)
		self:Tag(NameText2, "[name]") -- oUF will automagically update it!
		]]--
		--------------------------
		--  Player Power Values --
		--------------------------
		local MaxMana = UnitPowerMax("player", 0)
		local Mana = UnitPower("player", 0)
		local ManaPercent = math.floor(Mana / MaxMana * 100 + .5)
		local PowerText = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText:SetPoint("RIGHT", self, -10,-23) -- but anchor to the base element so it doesn't wiggle
		PowerText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		--self:Tag(PowerText, "[perpp]") -- oUF will automagically update it!
		PowerText:SetText(ManaPercent.."%")
		PowerText:SetAlpha(1) -- oUF will automagically update it!

		local PowerText2 = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText2:SetPoint("LEFT", self, 10,-23) -- but anchor to the base element so it doesn't wiggle
		PowerText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(PowerText2, "[curpp]") -- oUF will automagically update it!
		PowerText2:SetAlpha(1) -- oUF will automagically update it!

		local PowerText3 = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText3:SetPoint("CENTER", self, 0,-23) -- but anchor to the base element so it doesn't wiggle
		PowerText3:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(PowerText3, "[curpp]") -- oUF will automagically update it!
		PowerText3:SetAlpha(0)

		local function UltraFunction()
					if(select(2, UnitClass('player')) == 'WARRIOR') or (select(2, UnitClass('player')) == 'ROGUE') or (select(2, UnitClass('player')) == 'DRUID')  then
						if(select(2, UnitClass('player')) == 'DRUID') then
							local form = GetShapeshiftFormID()
							if (form == BEAR_FORM or form == CAT_FORM) then
								PowerText3:SetAlpha(1)
								self:Tag(PowerText3, "[curpp]")
								PowerText2:SetAlpha(0)
								PowerText:SetAlpha(0)
								else
								local MaxMana = UnitPowerMax("player", 0)
								local Mana = UnitPower("player", 0)
								local druidPercent = math.floor(Mana / MaxMana * 100 + .5)
								self:Tag(PowerText2, "")
								self:Tag(PowerText, "")
								PowerText3:SetAlpha(0)
								PowerText2:SetAlpha(1)
								PowerText2:SetText(Mana)
								PowerText:SetAlpha(1)
								PowerText:SetText(druidPercent.."%")
							end
						elseif(select(2, UnitClass('player')) == 'WARRIOR') then
							PowerText3:SetAlpha(1)
							PowerText2:SetAlpha(0)
							PowerText:SetAlpha(0)
						elseif(select(2, UnitClass('player')) == 'ROGUE') then
							PowerText3:SetAlpha(1)
							PowerText2:SetAlpha(0)
							PowerText:SetAlpha(0)
						end
					else
						PowerText3:SetAlpha(0)
						PowerText2:SetAlpha(1)
						PowerText:SetAlpha(1)
					end
				end
		local UltraEvent = CreateFrame("FRAME")
		UltraEvent:HookScript("OnUpdate", UltraFunction)



		---------------------------
		--  Player Health Values --
		---------------------------
		local MaxHealth = UnitHealthMax("player")
		local Health = UnitHealth("player")
		local HealthPercent = math.floor(Health / MaxHealth * 100 + .5)
		local HealthText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText:SetPoint("RIGHT", self, -10,0) -- but anchor to the base element so it doesn't wiggle
		HealthText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		HealthText:SetText(HealthPercent.."%")
		--self:Tag(HealthText, "[perhp]") -- oUF will automagically update it!

		local HealthText2 = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText2:SetPoint("LEFT", self, 10,0) -- but anchor to the base element so it doesn't wiggle
		HealthText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(HealthText2, "[curhp]") -- oUF will automagically update it!


		------------------------------------------
		--  Player Health and Power Adjustments --
		------------------------------------------

		self.Health:SetHeight(45)
		self.Power:SetHeight(22)
		self.Power:SetPoint('BOTTOM', self.Health,'BOTTOM', 0, -22)

		----------------------
		--  Player Cast Bar --
		----------------------

		self.Castbar:SetSize(225, 15)
		self.Castbar:SetPoint('BOTTOMRIGHT', self.Power, 0, -20)

		--self.Castbar:SetReverseFill(true)

		------------------
		--  Player Aura --
		------------------
		if Inked.db.char.PlayerAuraIcons == true then
			local Auras = CreateFrame("Frame", nil, self)
			Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0,25)
			Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 0, 25)
			Auras:SetHeight(30)
			Auras:SetHeight(30 + 4)

			Auras.size = 30
			Auras.onlyShowPlayer = false
			Auras.disableMouse = false
			Auras.gap = 5
			Auras.spacing = 8
			Auras.showStealableAuras = true
			Auras.disableCooldown = false
			Auras.num = 16

			Auras.PostCreateIcon = Aura_PostCreateIcon

			self.Auras = Auras
			end






		------------------
		--  Player Floating Combat Text --
		------------------
	if Inked.db.char.InkedFloatingCombatText == true then
		local fcf = CreateFrame("Frame", nil, self)
		fcf:SetSize(32, 32)
		fcf:SetPoint("CENTER",40,200)

		for i = 1, 6 do
		-- give names to these font strings to avoid breaking /fstack and /tinspect
			fcf[i] = fcf:CreateFontString("$parentFCFText" .. i, "OVERLAY")
		end

		fcf.font = "Interface\\Addons\\Inked\\Fonts\\Numbers.TTF"
		fcf.fontHeight = 24
		fcf.fontFlags = "OUTLINE"

		self.FloatingCombatFeedback = fcf

	end
		-------------------------
		--  Player Combat Icon --
		-------------------------

		local CombatAlertFrame = CreateFrame("Frame")
		CombatAlertFrame:SetSize(32,32)
		CombatAlertFrame:SetPoint("RIGHT", self, 32,0)
		CombatAlertFrame:Hide()
		CombatAlertFrame.Bg = CombatAlertFrame:CreateTexture(nil, "BACKGROUND")
		CombatAlertFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\combat")
		CombatAlertFrame.Bg:SetPoint("RIGHT", self, 32,0)
		CombatAlertFrame.Bg:SetSize(32, 32)


		CombatAlertFrame:SetScript("OnEvent", function(self, event, ...)
			if (event == "PLAYER_REGEN_DISABLED") then
				CombatAlertFrame:Show()
			elseif (event == "PLAYER_REGEN_ENABLED") then
				CombatAlertFrame:Hide()
			end
		end)
		CombatAlertFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
		CombatAlertFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
		-----------------------
		--  Player Rest Icon --
		-----------------------

	local CombatRestFrame = CreateFrame("Frame")
	CombatRestFrame:SetSize(32, 32)
	CombatRestFrame:SetPoint("TOPLEFT",self,"TOPLEFT",-30,30)
	CombatRestFrame:Hide()
	CombatRestFrame.Bg = CombatRestFrame:CreateTexture(nil, "BACKGROUND")
	CombatRestFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\resting")
	CombatRestFrame.Bg:SetPoint("TOPLEFT",self,"TOPLEFT",-30,30)
	CombatRestFrame.Bg:SetSize(32, 32)

	function RestMe()

		if IsResting() == true then
			CombatRestFrame:Show()
		end
		if IsResting() == false then
			CombatRestFrame:Hide()
		end
	end
	local RestMeframe = CreateFrame("Frame")
	RestMeframe:HookScript("OnUpdate", RestMe)

		----------------------
		--  Player PVP Icon --
		----------------------

		local PVPFrame = CreateFrame("Frame")
		PVPFrame:SetSize(32, 32)
		PVPFrame:SetPoint("LEFT",self,"LEFT", -32,0);
		PVPFrame:Hide()
		PVPFrame.Bg = PVPFrame:CreateTexture(nil, "BACKGROUND")
		PVPFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\pvp")
		local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r
				local MyGreen = color.g
				local MyBlue = color.b
		if UnitClass("player") == "Shaman" then
		MyRed = color.r * 0
		MyGreen = color.g * 0.44
		MyBlue = color.b * 0.87
		end
		PVPFrame.Bg:SetVertexColor(MyRed, MyGreen, MyBlue, 0.75);
		PVPFrame.Bg:SetPoint("LEFT",self,"LEFT", -32,-10);
		PVPFrame.Bg:SetSize(32, 32)
		function PlayerPVPMe()
			if UnitIsPVP("player") then
				PVPFrame:Show()
			else
				PVPFrame:Hide()
			end

		end
		local PlayerPVPMeframe = CreateFrame("Frame")
		PlayerPVPMeframe:HookScript("OnUpdate", PlayerPVPMe)

			---------------------------------
		--  Player Class Power  --
		---------------------------------

			local ClassPower = {}
			for index = 1, 10 do
			local Bar = CreateFrame('StatusBar', nil, self)
			Bar:SetStatusBarTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\DEFAULT_Status")
			CreateClassPowerBackdrop(Bar)

        -- Position and size.
			Bar:SetSize(30, 15)
			Bar:SetPoint('BOTTOMLEFT', self, 'TOPLEFT', (index - 1) * (Bar:GetWidth()+10), 5)

			ClassPower[index] = Bar
			end

		-- Register with oUF
		self.ClassPower = ClassPower
		-- Position and size
    local AlternativePower = CreateFrame('StatusBar', nil, self)
    AlternativePower:SetHeight(20)
    AlternativePower:SetPoint('BOTTOM')
    AlternativePower:SetPoint('LEFT')
    AlternativePower:SetPoint('RIGHT')

    -- Register with oUF
    self.AlternativePower = AlternativePower


	end,-- End Player
	boss = function(self)
	self:SetSize(225,65)


	--	self.Portrait:SetPoint('TOPRIGHT', self.Health, 'TOPLEFT', 0,0)
	--	self.Portrait:SetSize(65, 65)

		self.Health:SetHeight(65-20)
		self.Power:SetHeight(65-45)

		self.Castbar:SetSize(225+65, 25)
		self.Castbar:SetPoint('BOTTOM', self.Power, -32, -27)

		local Auras = CreateFrame("Frame", nil, self)
			Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0,25)
			Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 0, 25)
			Auras:SetHeight(30)
			Auras:SetHeight(30 + 4)

			Auras.size = 30
			Auras.onlyShowPlayer = false
			Auras.disableMouse = false
			Auras.gap = 5
			Auras.spacing = 8
			Auras.showStealableAuras = true
			Auras.disableCooldown = false
			Auras.num = 16

			Auras.PostCreateIcon = Aura_PostCreateIcon

			self.Auras = Auras

			---Raid Target
			-- Position and size
    local RaidTargetIndicator = self:CreateTexture(nil, 'OVERLAY')
    RaidTargetIndicator:SetSize(20, 20)
    RaidTargetIndicator:SetPoint('TOPRIGHT', self)

    -- Register it with oUF
    self.RaidTargetIndicator = RaidTargetIndicator

	end, --end boss
	pet = function(self)
		-- pet specific stuff
		---------------------------
		--  Player Pet Set Up  --
		---------------------------

		self:SetSize(145,40)


		------------------------
		--  Player Pet Level  --
		------------------------

		local LevelText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		LevelText:SetPoint("LEFT", self, -35,15) -- but anchor to the base element so it doesn't wiggle
		LevelText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 13, "OUTLINE")
		self:Tag(LevelText, "[level]") -- oUF will automagically update it!

		---------------------------
		--  Player Pet Name  --
		---------------------------

		local NameText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOPLEFT", self, 0,2) -- but anchor to the base element so it doesn't wiggle
		NameText:SetJustifyH("LEFT")
		NameText:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 15, "OUTLINE")
		NameText:SetWidth(300)
		self:Tag(NameText, "[name]") -- oUF will automagically update it!

		-------------------------------
		--  Player Pet Power Values  --
		-------------------------------

		local PowerText = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText:SetPoint("RIGHT", self, -5,-15) -- but anchor to the base element so it doesn't wiggle
		PowerText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 9, "OUTLINE")
		self:Tag(PowerText, "[perpp]") -- oUF will automagically update it!

		local PowerText2 = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText2:SetPoint("LEFT", self, 5,-15) -- but anchor to the base element so it doesn't wiggle
		PowerText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 9, "OUTLINE")
		self:Tag(PowerText2, "[curpp]") -- oUF will automagically update it!

		--------------------------------
		--  Player Pet Health Values  --
		--------------------------------

		local HealthText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText:SetPoint("RIGHT", self,-5,2) -- but anchor to the base element so it doesn't wiggle
		HealthText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 9, "OUTLINE")
		self:Tag(HealthText, "[perhp]") -- oUF will automagically update it!

		local HealthText2 = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText2:SetPoint("LEFT", self, 5,2) -- but anchor to the base element so it doesn't wiggle
		HealthText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 9, "OUTLINE")
		self:Tag(HealthText2, "[curhp]") -- oUF will automagically update it!

		---------------------------
		--  Player Pet Portrait  --
		---------------------------

		--self.Portrait:SetPoint('CENTER', self.Health, 'CENTER', 0,0)
		--self.Portrait:SetSize(145, 25)
		--self.Portrait:SetAlpha(0.45)
		-----------------------------------------------
		--  Player Pet Health and Power Adjustments  --
		-----------------------------------------------

		self.Health:SetHeight(25)
		self.Power:SetHeight(20)

		if UnitClass("player") == "Hunter" then

		end

		------------------------------------------------------
		--  Player Pet Cast Bar (Not Availible in Classic)  --
		------------------------------------------------------

		self.Castbar:SetPoint('CENTER', self.Power, 0, -25)
		self.Castbar:SetSize(145, 15)

		------------------------
		--  Player Pet Auras  --
		------------------------
		if Inked.db.char.PlayerAuraIcons == true then
		local Auras = CreateFrame("Frame", nil, self)
			Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0,4)
			Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 0, 4)
			Auras:SetHeight(20)
			Auras:SetHeight(20 + 4)

			Auras.size = 20
			Auras.onlyShowPlayer = false
			Auras.gap = 5
			Auras.spacing = 4
			Auras.showStealableAuras = true
			Auras.disableCooldown = false
			Auras.num = 16

			Auras.PostCreateIcon = Aura_PostCreateIcon
			self.Auras = Auras
			end



	end,-- End Pet
	target = function(self)

		--------------------
		--  Target Set Up --
		--------------------

		self:SetSize(235,65)



		-------------------------------------
		--  Adjust Target Health and Power --
		-------------------------------------

		self.Health:SetHeight(45)
		self.Power:SetHeight(20)
		self.Health:SetReverseFill(true)
		self.Power:SetReverseFill(true)

		-------------------------
		--  Target Level Value --
		-------------------------

		local LevelText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		LevelText:SetPoint("TOPLEFT", self, -35,-3) -- but anchor to the base element so it doesn't wiggle
		LevelText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(LevelText, "[level]") -- oUF will automagically update it!

		-------------------------
		--  Target Name Value --
		-------------------------

		local NameText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOPLEFT", self, 30,-3) -- but anchor to the base element so it doesn't wiggle
		NameText:SetJustifyH("LEFT")
		NameText:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 16, "OUTLINE")
		NameText:SetWidth(400)
		self:Tag(NameText, "[name]") -- oUF will automagically update it!

		-------------------------
		--  Target Power Value --
		-------------------------



		local PowerText = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText:SetPoint("RIGHT", self, -10,-23) -- but anchor to the base element so it doesn't wiggle
		PowerText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(PowerText, "[perpp]") -- oUF will automagically update it!



		local PowerText2 = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText2:SetPoint("LEFT", self, 10,-23) -- but anchor to the base element so it doesn't wiggle
		PowerText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(PowerText2, "[curpp]") -- oUF will automagically update it!


		--------------------------
		--  Target Health Value --
		--------------------------
		local HealthText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText:SetPoint("RIGHT", self, -10,0) -- but anchor to the base element so it doesn't wiggle
		HealthText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(HealthText, "[perhp]") -- oUF will automagically update it!


		local HealthText2 = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText2:SetPoint("LEFT", self, 10,0) -- but anchor to the base element so it doesn't wiggle
		HealthText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(HealthText2, "[curhp]") -- oUF will automagically update it!


		----------------------
		--  Target Portrait --
		----------------------

		--self.Portrait:SetPoint('CENTER', self, 'CENTER', 0, 0)
		--self.Portrait:SetSize(235, 65)
		--self.Portrait:SetAlpha(0.45)
		-----------------------
		--  Target Cast bar --
		-----------------------

		self.Castbar:SetSize(233, 15)
		self.Castbar:SetPoint('BOTTOMLEFT', self.Power, 0, -18)
		self.Castbar:SetReverseFill(true)
		-----------------------------
		-- Target Auras
		-----------------------------
		if Inked.db.char.PlayerAuraIcons == true then
		local Auras = CreateFrame("Frame", nil, self)
		Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0,25)
		Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 0, 25)
		Auras:SetHeight(30)
		Auras:SetHeight(30 + 4)

		Auras.size = 30
		Auras.onlyShowPlayer = false
		Auras.gap = 5
		Auras.spacing = 4
		Auras.showStealableAuras = true
		Auras.disableCooldown = false
		Auras.num = 16

		Auras.PostCreateIcon = Aura_PostCreateIcon
		self.Auras = Auras
		end
			-----------------
		--  Target Floating Combat Text--
		-----------------
		if Inked.db.char.InkedFloatingCombatText == true then
		local fcf = CreateFrame("Frame", nil, self)
		fcf:SetSize(32, 32)
		fcf:SetPoint("CENTER",-40,200)

		for i = 1, 6 do
			-- give names to these font strings to avoid breaking /fstack and /tinspect
			fcf[i] = fcf:CreateFontString("$parentFCFText" .. i, "OVERLAY")
		end

		fcf.font = "Interface\\Addons\\Inked\\Fonts\\Numbers.TTF"
		fcf.fontHeight = 24
		fcf.fontFlags = "OUTLINE"

		self.FloatingCombatFeedback = fcf
		end
		-----------------
		--  Target PVP --
		-----------------

		local TargetPVPFrame = CreateFrame("Frame")
		TargetPVPFrame:SetSize(32, 32)
		TargetPVPFrame:SetPoint("RIGHT", self, 32,0);
		TargetPVPFrame:Hide()
		TargetPVPFrame.Bg = TargetPVPFrame:CreateTexture(nil, "BACKGROUND")
			local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r
				local MyGreen = color.g
				local MyBlue = color.b
		if UnitClass("player") == "Shaman" then
		MyRed = color.r * 0
		MyGreen = color.g * 0.44
		MyBlue = color.b * 0.87
		end
		TargetPVPFrame.Bg:SetVertexColor(MyRed, MyGreen, MyBlue, 0.95);
		TargetPVPFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\pvp")
		TargetPVPFrame.Bg:SetPoint("RIGHT", self, 32,0);
		TargetPVPFrame.Bg:SetSize(32, 32)
		function PVPMe()
			if UnitIsPVP("target") then
				TargetPVPFrame:Show()
			else
				TargetPVPFrame:Hide()
			end

		end
		local PVPMeframe = CreateFrame("Frame")
		PVPMeframe:HookScript("OnUpdate", PVPMe)

		local TargetEliteFrame = CreateFrame("Frame")
		TargetEliteFrame:SetSize(64, 32)
		TargetEliteFrame:SetPoint("RIGHT", self,64,-32);
		TargetEliteFrame:Hide()
		TargetEliteFrame.Bg = TargetEliteFrame:CreateTexture(nil, "BACKGROUND")
			local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r
				local MyGreen = color.g
				local MyBlue = color.b
		if UnitClass("player") == "Shaman" then
		MyRed = color.r * 0
		MyGreen = color.g * 0.44
		MyBlue = color.b * 0.87
		end
		TargetEliteFrame.Bg:SetVertexColor(MyRed, MyGreen, MyBlue, 0.95);
		TargetEliteFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\pvp")
		TargetEliteFrame.Bg:SetPoint("RIGHT", self, 64,-32);
		TargetEliteFrame.Bg:SetSize(64, 32)

			-------------------
			--  Elite Units --
			-------------------
		local TargetEliteFrame = CreateFrame("Frame")
		TargetEliteFrame:SetSize(64, 32)
		TargetEliteFrame:SetPoint("RIGHT", self,64,-32);
		TargetEliteFrame:Hide()
		TargetEliteFrame.Bg = TargetEliteFrame:CreateTexture(nil, "BACKGROUND")
			local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r
				local MyGreen = color.g
				local MyBlue = color.b

		TargetEliteFrame.Bg:SetVertexColor(MyRed, MyGreen, MyBlue, 0.95);
		TargetEliteFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\EliteDragons")
		TargetEliteFrame.Bg:SetPoint("RIGHT", self, 64,-32);
		TargetEliteFrame.Bg:SetSize(64, 32)

		function EliteMe()
				if UnitClassification("target") == "elite"  then
						TargetEliteFrame:Show()
						TargetEliteFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\EliteDragons")
				end
				if UnitClassification("target") ~= "elite"  then
						TargetEliteFrame:Hide()
				end


		end
		local EliteMeframe = CreateFrame("Frame")
		EliteMeframe:HookScript("OnUpdate", EliteMe)
			-------------------
			--  Rare Units --
			-------------------
		local TargetRareFrame = CreateFrame("Frame")
		TargetRareFrame:SetSize(64, 32)
		TargetRareFrame:SetPoint("RIGHT", self,64,-32);
		TargetRareFrame:Hide()
		TargetRareFrame.Bg = TargetRareFrame:CreateTexture(nil, "BACKGROUND")
			local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r
				local MyGreen = color.g
				local MyBlue = color.b

		TargetRareFrame.Bg:SetVertexColor(MyRed, MyGreen, MyBlue, 0.95);
		TargetRareFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\EliteDragons")
		TargetRareFrame.Bg:SetPoint("RIGHT", self, 64,-32);
		TargetRareFrame.Bg:SetSize(64, 32)

		function RareMe()
				if UnitClassification("target") == "rare"  then
						TargetRareFrame:Show()
						TargetRareFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\RareEliteDragons")
				end
				if UnitClassification("target") ~= "rare"  then
						TargetRareFrame:Hide()
				end


		end
		local RareMeframe = CreateFrame("Frame")
		RareMeframe:HookScript("OnUpdate", RareMe)

			-----------------------
			--  Rare Elite Units --
			-----------------------
		local TargetRareEliteFrame = CreateFrame("Frame")
		TargetRareEliteFrame:SetSize(64, 32)
		TargetRareEliteFrame:SetPoint("RIGHT", self,64,-32);
		TargetRareEliteFrame:Hide()
		TargetRareEliteFrame.Bg = TargetRareEliteFrame:CreateTexture(nil, "BACKGROUND")
			local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r
				local MyGreen = color.g
				local MyBlue = color.b

		TargetRareEliteFrame.Bg:SetVertexColor(MyRed, MyGreen, MyBlue, 0.95);
		TargetRareEliteFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\EliteDragons")
		TargetRareEliteFrame.Bg:SetPoint("RIGHT", self, 64,-32);
		TargetRareEliteFrame.Bg:SetSize(64, 32)

		function RareEliteMe()
				if UnitClassification("target") == "rareelite"  then
						TargetRareEliteFrame:Show()
						TargetRareEliteFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\RareEliteDragons")
				end
				if UnitClassification("target") ~= "rareelite"  then
						TargetRareEliteFrame:Hide()
				end


		end
		local RareEliteMeframe = CreateFrame("Frame")
		RareEliteMeframe:HookScript("OnUpdate", RareEliteMe)

			-----------------------
			--  World Boss Units --
			-----------------------
		local TargetWorldBossFrame = CreateFrame("Frame")
		TargetWorldBossFrame:SetSize(64, 32)
		TargetWorldBossFrame:SetPoint("RIGHT", self,64,-32);
		TargetWorldBossFrame:Hide()
		TargetWorldBossFrame.Bg = TargetWorldBossFrame:CreateTexture(nil, "BACKGROUND")
			local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r
				local MyGreen = color.g
				local MyBlue = color.b

		TargetWorldBossFrame.Bg:SetVertexColor(MyRed, MyGreen, MyBlue, 0.95);
		TargetWorldBossFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\EliteDragons")
		TargetWorldBossFrame.Bg:SetPoint("RIGHT", self, 64,-32);
		TargetWorldBossFrame.Bg:SetSize(64, 32)

		function WorlBossMe()
				if UnitClassification("target") == "worldboss"  then
						TargetWorldBossFrame:Show()
						TargetWorldBossFrame.Bg:SetTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\RareEliteDragons")
				end
				if UnitClassification("target") ~= "worldboss"  then
						TargetWorldBossFrame:Hide()
				end


		end
		local WorlBossMeframe = CreateFrame("Frame")
		WorlBossMeframe:HookScript("OnUpdate", WorlBossMe)

	end, -- End Target
	focus = function(self)

		--------------------
		--  Target Set Up --
		--------------------

		self:SetSize(235,65)
		self:SetScale(0.85)


		-------------------------------------
		--  Adjust Target Health and Power --
		-------------------------------------

		self.Health:SetHeight(45)
		self.Power:SetHeight(20)
		self.Health:SetReverseFill(true)
		self.Power:SetReverseFill(true)

		-------------------------
		--  Target Level Value --
		-------------------------

		local LevelText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		LevelText:SetPoint("TOPLEFT", self, -35,-3) -- but anchor to the base element so it doesn't wiggle
		LevelText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(LevelText, "[level]") -- oUF will automagically update it!

		-------------------------
		--  Target Name Value --
		-------------------------

		local NameText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOPLEFT", self, 30,-3) -- but anchor to the base element so it doesn't wiggle
		NameText:SetJustifyH("LEFT")
		NameText:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 16, "OUTLINE")
		NameText:SetWidth(400)
		self:Tag(NameText, "[name]") -- oUF will automagically update it!

		-------------------------
		--  Target Power Value --
		-------------------------



		local PowerText = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText:SetPoint("RIGHT", self, -10,-23) -- but anchor to the base element so it doesn't wiggle
		PowerText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(PowerText, "[perpp]") -- oUF will automagically update it!



		local PowerText2 = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText2:SetPoint("LEFT", self, 10,-23) -- but anchor to the base element so it doesn't wiggle
		PowerText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(PowerText2, "[curpp]") -- oUF will automagically update it!


		--------------------------
		--  Target Health Value --
		--------------------------
		local HealthText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText:SetPoint("RIGHT", self, -10,0) -- but anchor to the base element so it doesn't wiggle
		HealthText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(HealthText, "[perhp]") -- oUF will automagically update it!


		local HealthText2 = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText2:SetPoint("LEFT", self, 10,0) -- but anchor to the base element so it doesn't wiggle
		HealthText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 14, "OUTLINE")
		self:Tag(HealthText2, "[curhp]") -- oUF will automagically update it!


		----------------------
		--  Target Portrait --
		----------------------

		--self.Portrait:SetPoint('CENTER', self, 'CENTER', 0, 0)
		--self.Portrait:SetSize(235, 65)
		--self.Portrait:SetAlpha(0.45)
		-----------------------
		--  Target Cast bar --
		-----------------------

		self.Castbar:SetSize(233, 15)
		self.Castbar:SetPoint('BOTTOMLEFT', self.Power, 0, -18)
		self.Castbar:SetReverseFill(true)
		-----------------------------
		-- Target Auras
		-----------------------------
		if Inked.db.char.PlayerAuraIcons == true then
		local Auras = CreateFrame("Frame", nil, self)
		Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0,25)
		Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 0, 25)
		Auras:SetHeight(30)
		Auras:SetHeight(30 + 4)

		Auras.size = 30
		Auras.onlyShowPlayer = false
		Auras.gap = 5
		Auras.spacing = 4
		Auras.showStealableAuras = true
		Auras.disableCooldown = false
		Auras.num = 16

		Auras.PostCreateIcon = Aura_PostCreateIcon
		self.Auras = Auras
		end

	end, -- End Target
	targettarget = function(self)
		self:SetSize(165,40)


		----------------------------------
		-- Target of Target Level Text --
		----------------------------------

		local LevelText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		LevelText:SetPoint("LEFT", self, -25,0) -- but anchor to the base element so it doesn't wiggle
		LevelText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 11, "OUTLINE")
		self:Tag(LevelText, "[level]") -- oUF will automagically update it!

		---------------------------------
		-- Target of Target Name Text --
		---------------------------------

		local NameText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOPLEFT", self, 0,2) -- but anchor to the base element so it doesn't wiggle
		NameText:SetJustifyH("LEFT")
		NameText:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 10, "OUTLINE")
		NameText:SetWidth(300)
		self:Tag(NameText, "[name]") -- oUF will automagically update it!

		----------------------------------
		-- Target of Target Power Value --
		----------------------------------

		local PowerText = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText:SetPoint("RIGHT", self, -5,-15) -- but anchor to the base element so it doesn't wiggle
		PowerText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 6, "OUTLINE")
		self:Tag(PowerText, "[perpp]") -- oUF will automagically update it!

		local PowerText2 = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText2:SetPoint("LEFT", self, 5,-15) -- but anchor to the base element so it doesn't wiggle
		PowerText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 6, "OUTLINE")
		self:Tag(PowerText2, "[curpp]") -- oUF will automagically update it!

		-----------------------------------
		-- Target of Target Health Value --
		-----------------------------------

		local HealthText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText:SetPoint("RIGHT", self, -5,0) -- but anchor to the base element so it doesn't wiggle
		HealthText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 7, "OUTLINE")
		self:Tag(HealthText, "[perhp]") -- oUF will automagically update it!

		local HealthText2 = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText2:SetPoint("LEFT", self, 5,0) -- but anchor to the base element so it doesn't wiggle
		HealthText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 7, "OUTLINE")
		self:Tag(HealthText2, "[curhp]") -- oUF will automagically update it!

		-------------------------------
		-- Target of Target Portrait --
		-------------------------------

		--self.Portrait:SetPoint('CENTER', self, 'CENTER', 0,0)
		--self.Portrait:SetSize(165, 35)
		--self.Portrait:SetAlpha(0.45)
		-------------------------------------------------------
		-- Target of Target Health and Power Bar Adjustments --
		-------------------------------------------------------

		self.Health:SetHeight(30)

		self.Power:SetHeight(10)
		self.Power:SetPoint('BOTTOM',self.Health,'BOTTOM',0,-10)
		-------------------------------
		-- Target of Target Cast Bar --
		-------------------------------

		self.Castbar:Hide()

	end, -- End Target of Target
	focustarget = function(self)
		self:SetSize(165,40)


		----------------------------------
		-- Target of Target Level Text --
		----------------------------------

		local LevelText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		LevelText:SetPoint("LEFT", self, -25,0) -- but anchor to the base element so it doesn't wiggle
		LevelText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 11, "OUTLINE")
		self:Tag(LevelText, "[level]") -- oUF will automagically update it!

		---------------------------------
		-- Target of Target Name Text --
		---------------------------------

		local NameText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOPLEFT", self, 0,2) -- but anchor to the base element so it doesn't wiggle
		NameText:SetJustifyH("LEFT")
		NameText:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 10, "OUTLINE")
		NameText:SetWidth(300)
		self:Tag(NameText, "[name]") -- oUF will automagically update it!

		----------------------------------
		-- Target of Target Power Value --
		----------------------------------

		local PowerText = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText:SetPoint("RIGHT", self, -5,-15) -- but anchor to the base element so it doesn't wiggle
		PowerText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 6, "OUTLINE")
		self:Tag(PowerText, "[perpp]") -- oUF will automagically update it!

		local PowerText2 = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText2:SetPoint("LEFT", self, 5,-15) -- but anchor to the base element so it doesn't wiggle
		PowerText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 6, "OUTLINE")
		self:Tag(PowerText2, "[curpp]") -- oUF will automagically update it!

		-----------------------------------
		-- Target of Target Health Value --
		-----------------------------------

		local HealthText = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText:SetPoint("RIGHT", self, -5,0) -- but anchor to the base element so it doesn't wiggle
		HealthText:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 7, "OUTLINE")
		self:Tag(HealthText, "[perhp]") -- oUF will automagically update it!

		local HealthText2 = self.Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText2:SetPoint("LEFT", self, 5,0) -- but anchor to the base element so it doesn't wiggle
		HealthText2:SetFont("Interface\\Addons\\Inked\\Fonts\\Numbers.TTF", 7, "OUTLINE")
		self:Tag(HealthText2, "[curhp]") -- oUF will automagically update it!

		-------------------------------
		-- Target of Target Portrait --
		-------------------------------

		--self.Portrait:SetPoint('CENTER', self, 'CENTER', 0,0)
		--self.Portrait:SetSize(165, 35)
		--self.Portrait:SetAlpha(0.45)
		-------------------------------------------------------
		-- Target of Target Health and Power Bar Adjustments --
		-------------------------------------------------------

		self.Health:SetHeight(30)

		self.Power:SetHeight(10)
		self.Power:SetPoint('BOTTOM',self.Health,'BOTTOM',0,-10)
		-------------------------------
		-- Target of Target Cast Bar --
		-------------------------------

		self.Castbar:Hide()

	end, -- End Target of Target
}
	UnitSpecific.arena = UnitSpecific.boss

local Shared = function(self, unit)
	-- Shared layout code.

	-----------------
	--  Mouse Code --
	-----------------
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:RegisterForClicks'AnyUp'
	------------------
	--  Health Bars --
	------------------

	local Health = CreateFrame("StatusBar", nil, self)
	Health:SetStatusBarTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\DEFAULT_Status")
	Health:SetPoint('TOP')
	Health:SetPoint('LEFT')
	Health:SetPoint('RIGHT')
	CreateHealthBackdrop(Health)

	-- Options
	Health.frequentUpdates = true
	Health.colorTapping = true
	Health.colorDisconnected = true
	Health.colorClass = true
	Health.colorReaction = true
	Health.colorHealth = true
	-- Register it with oUF
	self.Health = Health
	self.Health.bg = Healthbg


    -----------------
	--  Power Bars --
	-----------------

	local Power = CreateFrame("StatusBar", nil, Health)
	Power:SetStatusBarTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\DEFAULT_Status")
	Power:SetPoint('BOTTOM',Health,'BOTTOM',0,-20)
	Power:SetPoint('LEFT')
	Power:SetPoint('RIGHT')
	Power:SetAlpha(0.75)
	CreatePowerBackdrop(Power)
	-- Options
	Power.frequentUpdates = true
	Power.colorPower = true -- powertype colored bar
	Power.colorClassNPC = false -- color power based on NPC
	Power.colorClassPet = false -- color power based on pet type
	-- Register it with oUF
	self.Power = Power
	self.Power.bg = Powerbg


	------------------
	--  3D Portrait --
	------------------

	-- Position and size
	--local Portrait = CreateFrame('PlayerModel', nil, self)

--	CreateBackdrop(Portrait)
--	 Portrait:SetBackdrop({bgFile = "Interface\\Addons\\Inked\\Assets\\Buttons\\UNIT-BG13",
   --     insets = {top = 0, left = 0, bottom = 0, right = 0}})
	--	Portrait:SetBackdropColor(0.45,0.45,0.45,0.95)


	-- Register it with oUF
	--self.Portrait = Portrait
	--------------
	-- Cast Bar --
	--------------

	-- Position and size
	local Castbar = CreateFrame("StatusBar", nil, self)
	Castbar:SetStatusBarTexture("Interface\\Addons\\Inked\\Textures\\Unit Frames\\DEFAULT_Status")
	local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
				local MyRed = color.r
				local MyGreen = color.g
				local MyBlue = color.b
	if UnitClass("player") == "Shaman" then
		MyRed = color.r * 0
		MyGreen = color.g * 0.44
		MyBlue = color.b * 0.87
	end
	Castbar:SetStatusBarColor(MyRed,MyGreen,MyBlue,1)


	-- Add a background
	CreateSpellBackdrop(Castbar)
	-- Add a spark
	local Spark = Castbar:CreateTexture(nil, "OVERLAY")
	Spark:SetSize(45, 45)
	Spark:SetBlendMode("ADD")

	-- Add a timer
	local Time = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
	Time:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 14, "OUTLINE")
	Time:SetTextColor(1, 1, 1)
	Time:SetPoint("RIGHT", Castbar, -3, 1)
	--Time:SetAlpha(0.35)

	-- Add spell text
	local Text = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
	Text:SetFont("Interface\\Addons\\Inked\\Fonts\\Dialog.TTF", 11, "OUTLINE")
	Text:SetTextColor(1, 1, 1)
	Text:SetPoint("LEFT", Castbar, 3, 1)
	Text:SetAlpha(1)

	-- Add Shield
	local Shield = Castbar:CreateTexture(nil, "OVERLAY")
	Shield:SetSize(25, 15)
	Shield:SetPoint("CENTER", Castbar)

	--local Icon = Castbar:CreateTexture(nil, 'OVERLAY')
   -- Icon:SetSize(20, 20)
   -- Icon:SetPoint('LEFT', Castbar, 'LEFT',-20,0)
	-- Add safezone
	local SafeZone = Castbar:CreateTexture(nil, "OVERLAY")

	-- Register it with oUF
	self.Castbar = Castbar
	self.Castbar.bg = Background
	self.Castbar.Spark = Spark
	self.Castbar.Time = Time
	self.Castbar.Text = Text
	self.Castbar.SafeZone = SafeZone
	--self.Castbar.Icon = Icon



	-----------------
	-- Smooth Bars --
	-----------------

	self.Health.Smooth = true
		if self.Power then
			self.Power.Smooth = true
		end

	--------------
	-- Rez Icon --
	--------------

	-- Position and sizew
	local ResurrectIcon = self.Health:CreateTexture(nil, 'OVERLAY')
	ResurrectIcon:SetSize(16, 16)
	ResurrectIcon:SetPoint('CENTER', self.Health)

	-- Register it with oUF
	self.ResurrectIcon = ResurrectIcon

	----------------
	-- Raid icons --
	----------------

	-- Position and size
	local RaidTargetIndicator = self.Health:CreateTexture(nil, 'OVERLAY')
	RaidTargetIndicator:SetSize(16, 16)
	RaidTargetIndicator:SetPoint('CENTER', self.Health)

	-- Register it with oUF
	self.RaidTargetIndicator = RaidTargetIndicator

	if(UnitSpecific[unit]) then
		return UnitSpecific[unit](self)
		end
end

oUF:RegisterStyle("keivampLayout4", Shared)
oUF:Factory(function(self)
if Inked.db.char.UF4  == false then return end
	-----------------
	-- Unit Set Up --
	-----------------
     self:SetActiveStyle("keivampLayout4")
     self:Spawn("player"):SetPoint("CENTER",UIParent,"CENTER",-235,-250)
	 self:Spawn("target"):SetPoint("CENTER",UIParent,"CENTER",235,-250)
	 self:Spawn("pet"):SetPoint("CENTER",UIParent,"CENTER",-375,-375)
	 self:Spawn("targettarget"):SetPoint("CENTER",UIParent,"CENTER",375,-375)
	 self:Spawn("focus"):SetPoint("CENTER",UIParent,"CENTER",-535,75)
	 self:Spawn("focustarget"):SetPoint("CENTER",UIParent,"CENTER",-535,-75)
	 self:Spawn("boss"):SetPoint("CENTER",UIParent,"CENTER",0,250)

end)
